//
//  ChatProtocols.swift
//  VKExt
//
//  Created programmist_NA on 31.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit

//MARK: Wireframe -
protocol ChatWireframeProtocol: class {
    
}
//MARK: Presenter -
protocol ChatPresenterProtocol: class {
    var messagesCount: Int { get }
    func start(offset: Int, peerId: Int, count: Int)
    func onEvent(message: String, _ style: MessageViewState)
    func onError(message: String, _ style: MessageViewState)
    func onSendMessage(message: String, peerId: Int, randomId: Int64)
    func onDeleteMessage(messageId: Int, removeFromAll: Bool)
    func onEditMessage(message: String, messageId: Int, peerId: Int)
}

//MARK: Interactor -
protocol ChatInteractorProtocol: class {
    var presenter: ChatPresenterProtocol?  { get set }
    var chatMessagesCount: Int { get }
    func start(offset: Int, peerId: Int, count: Int)
    func sendMessage(message: String, peerId: Int, randomId: Int64)
    func removeMessage(messageId: Int, removeFromAll: Bool)
    func edit(message: String, messageId: Int, peerId: Int)
}

//MARK: View -
protocol ChatViewProtocol: class {
    var presenter: ChatPresenterProtocol?  { get set }
    var peerId: Int? { get }
}
